--datedemo.ex
--shows usage of procedures in date.e
--by David Money, September, 2005

--Note that all dates, times, and time zone designations are input as strings.  
--Offsets for show_new_date and show_new_time are input as integers (days or
--seconds).  All functions return dates, times, or intervals as strings.
--Dates can be from A.D.100 on (years from 00 to 99 are interpreted as being
--in the current century between 1940 and 2039; change First2 variable if you
--want a different range).  Dates before 1582 are calculated with leap years
--every four years.  Calendar was changed that year, and ten days were removed:
--the day after Oct. 4 was Oct. 15, although some countries did not change for
--quite a few years.  Look up Gregorian calendar if you are interested.

--Calendar functions added: Calendar requires integer for year and month (year
--can be 2 digits).  Current_calendar finds date from system, has no parameters.

include date.e
ReadDateMode=2 --U.S. style input (M/D/Y)
PrintDateMode=27 --spell out day, month
PrintTimeMode=4 --12-hr., with seconds

printf(1,"Today's date is %s.\n",{show_date("today")})
printf(1,"The current time is %s.\n\n",{show_time("now")})
--also accepts tomorrow, yesterday; noon, midnight

printf(1,"Christmas will be on %s.\n",{show_date("12/25/05")})
printf(1,"The show is on from %s to %s.\n\n",{show_time("7:00pm"),show_time("20:30:00")})
--interprets either format automatically (12-hr. mode must include a/p)

PrintDateMode=13 --Euro style, abbreviate day of week
PrintTimeMode=1 --24-hr. mode, no seconds
printf(1,"Two weeks from tomorrow will be %s.\n",{show_new_date("tommor",14)})
printf(1,"An hour ago it was %s.\n",{show_new_time("now",-3600)})
printf(1,"Thirty days and five minutes ago, it was %s.\n\n",
    {show_new_date_time("today","now",-30,-300)})
printf(1,"I am on Eastern Daylight time.  At noon my time it is %s in Japan.\n\n",
    {different_zone("noon","edt","JST")})
--most time zones do not have standard abbreviations, except in U.S. and Europe;
--military zone codes A-Z, or hour offset from GMT may also be used
printf(1,"It has been %s since the first day of the century.\n\n",{interval_days
    ("1.1.1","today")})
printf(1,"From 7:30 am to 4:00 pm is %s.\n\n",{interval_secs("7:30a","4:00PM")})
ReadDateMode=1 --international style (Y-M-D)
printf(1,"The 22nd century starts in %s.\n\n",{interval_days_secs("today","now",
    "2101-1-1","midn")})
--date may be entered with -,/, or . between numbers, but both must be the same.
printf(1,"Here is a calendar for this December:\n%s\n",{calendar(5,12)})

